<html>
<head>
<title>Ogre::Matrix4 Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::Matrix4 Class Reference<div class="ingroups"><a class="el" href="group__Math.html">Math</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::Matrix4" -->
<p>Class encapsulating a standard 4x4 homogeneous matrix.  
 <a href="classOgre_1_1Matrix4.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>&gt;</code></p>

<p><a href="classOgre_1_1Matrix4-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#abde37761a7b38997925b6805f6494f72">Matrix4</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor.  <a href="#abde37761a7b38997925b6805f6494f72"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a91cac2ee0f0e8bd582c24db497afcd21">Matrix4</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m00, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m01, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m02, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m03, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m10, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m11, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m12, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m13, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m20, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m21, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m22, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m23, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m30, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m31, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m32, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m33)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a8ae0763e439e87045b1ce46dca2c279c">Matrix4</a> (const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;m3x3)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a standard 4x4 transformation matrix with a zero translation part from a rotation/scaling 3x3 matrix.  <a href="#a8ae0763e439e87045b1ce46dca2c279c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#aaf7dc461a266459ab6916e7f97991969">Matrix4</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rot)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a standard 4x4 transformation matrix with a zero translation part from a rotation/scaling <a class="el" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>.  <a href="#aaf7dc461a266459ab6916e7f97991969"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a83b9aa92783c4679fc09307e74e92736">swap</a> (<a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;other)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Exchange the contents of this matrix with another.  <a href="#a83b9aa92783c4679fc09307e74e92736"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#aa996041c004dbfd5629120299ee0cb6f">operator[]</a> (size_t iRow)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a9e799f2922b54ced115226b14b1d3a0b">operator[]</a> (size_t iRow) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#aa61f91e4084cdc0adce4eb489a8f9898">concatenate</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a7afd9c17be1a09da49b11b2c1a9e4ccb">operator*</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Matrix concatenation using '*'.  <a href="#a7afd9c17be1a09da49b11b2c1a9e4ccb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a9a46d183f9470d7608e50a43ef327b46">operator*</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Vector transformation using '*'.  <a href="#a9a46d183f9470d7608e50a43ef327b46"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#ab120b3153610d0c92fe0876249c7d3ae">operator*</a> (const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;v) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html">Plane</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#adf4c418aa94944129f99dacd90ca29dd">operator*</a> (const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;p) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#ac0c54ddc64f9b832ab2656f514060fbb">operator+</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Matrix addition.  <a href="#ac0c54ddc64f9b832ab2656f514060fbb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a6c698c19379d5b4d2ff6e5dd186ad76c">operator-</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Matrix subtraction.  <a href="#a6c698c19379d5b4d2ff6e5dd186ad76c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a5eb73fdc4084eed850221ed14f558ff2">operator==</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Tests 2 matrices for equality.  <a href="#a5eb73fdc4084eed850221ed14f558ff2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a67d3ae14b6b68e6824f1a91d99da16f8">operator!=</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Tests 2 matrices for inequality.  <a href="#a67d3ae14b6b68e6824f1a91d99da16f8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a5c5f37c501d49692728909d11dd8c1de">operator=</a> (const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;mat3)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Assignment from 3x3 matrix.  <a href="#a5c5f37c501d49692728909d11dd8c1de"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#ae141496dd80a027493cfc0bea3952a4d">transpose</a> (void) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#aaf08a89733aa192a0d9e414e8b18ccf1">setTrans</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the translation transformation part of the matrix.  <a href="#aaf08a89733aa192a0d9e414e8b18ccf1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a928e9a44acf0f5a998392b272b117a4f">getTrans</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Extracts the translation transformation part of the matrix.  <a href="#a928e9a44acf0f5a998392b272b117a4f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#afb53c4fa6548001260d77dc283e3652f">makeTrans</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Builds a translation matrix.  <a href="#afb53c4fa6548001260d77dc283e3652f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a87f478c5d19a10a371b736108e0b5e5f">makeTrans</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> tx, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> ty, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> tz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a754a168ea4d55d40c9a24ef33eb41c95">setScale</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the scale part of the matrix.  <a href="#a754a168ea4d55d40c9a24ef33eb41c95"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a7c32a3b5d7675181995e917f66c18b69">extract3x3Matrix</a> (<a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;m3x3) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Extracts the rotation / scaling part of the Matrix as a 3x3 matrix.  <a href="#a7c32a3b5d7675181995e917f66c18b69"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a15aa8cfb2a09630c58c053649242d369">hasScale</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Determines if this matrix involves a scaling.  <a href="#a15aa8cfb2a09630c58c053649242d369"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#ad7b6df8db31a975c7d8e0b255bce236b">hasNegativeScale</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Determines if this matrix involves a negative scaling.  <a href="#ad7b6df8db31a975c7d8e0b255bce236b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#ae66aaed3ab33c1f2a9862bc21dde0608">extractQuaternion</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Extracts the rotation / scaling part as a quaternion from the Matrix.  <a href="#ae66aaed3ab33c1f2a9862bc21dde0608"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a33a5f250207da657e2dab3b3aa5f4d72">operator*</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> scalar) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a2570c4903858248e80bc6f34571c141a">adjoint</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a7e14122cbf6856b9701142cb6580aaa1">determinant</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a8879acb17e3029cf8bc2796b29ed8470">inverse</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a283bf568c924a673a1467c428d4b969d">makeTransform</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;position, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;scale, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;orientation)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Building a <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> from orientation / scale / position.  <a href="#a283bf568c924a673a1467c428d4b969d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a4e5949d1d1004070660f31036ee69523">makeInverseTransform</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;position, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;scale, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;orientation)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Building an inverse <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> from orientation / scale / position.  <a href="#a4e5949d1d1004070660f31036ee69523"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a2a45fd744a4ccfac9ed86578acf4923a">decomposition</a> (<a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;position, <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;scale, <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;orientation) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Decompose a <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> to orientation / scale / position.  <a href="#a2a45fd744a4ccfac9ed86578acf4923a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a582b20b912ed7d7f8f179505dfbe7a4e">isAffine</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Check whether or not the matrix is affine matrix.  <a href="#a582b20b912ed7d7f8f179505dfbe7a4e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a48cec18b03b16a9161d1c95b493a38a4">inverseAffine</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the inverse of the affine matrix.  <a href="#a48cec18b03b16a9161d1c95b493a38a4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a854210ca8faa1380f447e552c1d34191">concatenateAffine</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Concatenate two affine matrices.  <a href="#a854210ca8faa1380f447e552c1d34191"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#afcd6dae51beb8283338ad52ac63c86fb">transformAffine</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">3-D Vector transformation specially for an affine matrix.  <a href="#afcd6dae51beb8283338ad52ac63c86fb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a30bacec4331db3d61f8a43a0d8596595">transformAffine</a> (const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;v) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">4-D Vector transformation specially for an affine matrix.  <a href="#a30bacec4331db3d61f8a43a0d8596595"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a88fb90dffc0216a0a59bf19fad4eeace">getTrans</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets a translation matrix.  <a href="#a88fb90dffc0216a0a59bf19fad4eeace"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a3eedf9b0ea1245683a20f2e98ebd7e42">getTrans</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> t_x, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> t_y, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> t_z)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets a translation matrix - variation for not using a vector.  <a href="#a3eedf9b0ea1245683a20f2e98ebd7e42"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#adfddc3e047c6052647ebfa5ddb3fbe13">getScale</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets a scale matrix.  <a href="#adfddc3e047c6052647ebfa5ddb3fbe13"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a5bac8a5777be6cf9af08c98de120d562">getScale</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> s_x, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> s_y, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> s_z)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets a scale matrix - variation for not using a vector.  <a href="#a5bac8a5777be6cf9af08c98de120d562"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a838ac3cb744a01a39dfe35c61e942d7a">ZERO</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#ae2c11de10a963ad13ce3d3e802a05d60">ZEROAFFINE</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#af2f61127dd1911c9ac2b4cbc0b4f3668">IDENTITY</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a08a798c0d8c8290dbc0287ca6561f549">CLIPSPACE2DTOIMAGESPACE</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Useful little matrix which takes 2D clipspace {-1, 1} to {0,1} and inverts the Y.  <a href="#a08a798c0d8c8290dbc0287ca6561f549"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" >union {</td></tr>
<tr><td class="memItemLeft" >&#160;&#160;&#160;<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;&#160;&#160;<a class="el" href="classOgre_1_1Matrix4.html#a949708616d61b1c520d04bd9b0577324">m</a> [4][4]</td></tr>
<tr><td class="memItemLeft" >&#160;&#160;&#160;<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;&#160;&#160;<a class="el" href="classOgre_1_1Matrix4.html#a0d9aaf75aa94b65f4ec5fe1afb0cf4d1">_m</a> [16]</td></tr>
<tr><td class="memItemLeft" valign="top">};&#160;</td><td class="memItemRight" valign="bottom"></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The matrix entries, indexed by [row][col].  <a href="#a64e62f0586dd8550fd6b0fa0b6d200b5"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="friends"></a>
Friends</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#aa690d21c6464462d97145c8071ca5c29">operator&lt;&lt;</a> (std::ostream &amp;o, const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;mat)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Function for writing to a stream.  <a href="#aa690d21c6464462d97145c8071ca5c29"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class encapsulating a standard 4x4 homogeneous matrix. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>OGRE uses column vectors when applying matrix multiplications, This means a vector is represented as a single column, 4-row matrix. This has the effect that the transformations implemented by the matrices happens right-to-left e.g. if vector V is to be transformed by M1 then M2 then M3, the calculation would be M3 * M2 * M1 * V. The order that matrices are concatenated is vital since matrix multiplication is not commutative, i.e. you can get a different result if you concatenate in the wrong order. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>The use of column vectors and right-to-left ordering is the standard in most mathematical texts, and is the same as used in OpenGL. It is, however, the opposite of Direct3D, which has inexplicably chosen to differ from the accepted standard and uses row vectors and left-to-right matrix multiplication. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>OGRE deals with the differences between D3D and OpenGL etc. internally when operating through different render systems. OGRE users only need to conform to standard maths conventions, i.e. right-to-left matrix multiplication, (OGRE transposes matrices it passes to D3D to compensate). </dd></dl>
<dl class="user"><dt><b></b></dt><dd>The generic form M * V which shows the layout of the matrix entries is shown below: <pre>
                [ m[0][0]  m[0][1]  m[0][2]  m[0][3] ]   {x}
                | m[1][0]  m[1][1]  m[1][2]  m[1][3] | * {y}
                | m[2][0]  m[2][1]  m[2][2]  m[2][3] |   {z}
                [ m[3][0]  m[3][1]  m[3][2]  m[3][3] ]   {1}
            </pre> </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="abde37761a7b38997925b6805f6494f72"></a><!-- doxytag: member="Ogre::Matrix4::Matrix4" ref="abde37761a7b38997925b6805f6494f72" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html#abde37761a7b38997925b6805f6494f72">Ogre::Matrix4::Matrix4</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Default constructor. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>It does <b>NOT</b> initialize the matrix for efficiency. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00091">91</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="a91cac2ee0f0e8bd582c24db497afcd21"></a><!-- doxytag: member="Ogre::Matrix4::Matrix4" ref="a91cac2ee0f0e8bd582c24db497afcd21" args="(Real m00, Real m01, Real m02, Real m03, Real m10, Real m11, Real m12, Real m13, Real m20, Real m21, Real m22, Real m23, Real m30, Real m31, Real m32, Real m33)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html#abde37761a7b38997925b6805f6494f72">Ogre::Matrix4::Matrix4</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m00</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m01</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m02</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m03</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m10</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m11</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m12</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m13</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m20</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m21</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m22</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m23</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m30</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m31</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m32</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>m33</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8ae0763e439e87045b1ce46dca2c279c"></a><!-- doxytag: member="Ogre::Matrix4::Matrix4" ref="a8ae0763e439e87045b1ce46dca2c279c" args="(const Matrix3 &amp;m3x3)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html#abde37761a7b38997925b6805f6494f72">Ogre::Matrix4::Matrix4</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;&#160;</td>
          <td class="paramname"><em>m3x3</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Creates a standard 4x4 transformation matrix with a zero translation part from a rotation/scaling 3x3 matrix. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00122">122</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="aaf7dc461a266459ab6916e7f97991969"></a><!-- doxytag: member="Ogre::Matrix4::Matrix4" ref="aaf7dc461a266459ab6916e7f97991969" args="(const Quaternion &amp;rot)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html#abde37761a7b38997925b6805f6494f72">Ogre::Matrix4::Matrix4</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>rot</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Creates a standard 4x4 transformation matrix with a zero translation part from a rotation/scaling <a class="el" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00131">131</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1Quaternion.html#a7e6b9955074bf92c2b778dc0307769a2">Ogre::Quaternion::ToRotationMatrix()</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a2570c4903858248e80bc6f34571c141a"></a><!-- doxytag: member="Ogre::Matrix4::adjoint" ref="a2570c4903858248e80bc6f34571c141a" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#a2570c4903858248e80bc6f34571c141a">Ogre::Matrix4::adjoint</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aa61f91e4084cdc0adce4eb489a8f9898"></a><!-- doxytag: member="Ogre::Matrix4::concatenate" ref="aa61f91e4084cdc0adce4eb489a8f9898" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#aa61f91e4084cdc0adce4eb489a8f9898">Ogre::Matrix4::concatenate</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>m2</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00174">174</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>.</p>

</div>
</div>
<a class="anchor" id="a854210ca8faa1380f447e552c1d34191"></a><!-- doxytag: member="Ogre::Matrix4::concatenateAffine" ref="a854210ca8faa1380f447e552c1d34191" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#a854210ca8faa1380f447e552c1d34191">Ogre::Matrix4::concatenateAffine</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>m2</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Concatenate two affine matrices. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>The matrices must be affine matrix. </dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Matrix4.html#a582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">Matrix4::isAffine</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00587">587</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00572">isAffine()</a>, and <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>.</p>

</div>
</div>
<a class="anchor" id="a2a45fd744a4ccfac9ed86578acf4923a"></a><!-- doxytag: member="Ogre::Matrix4::decomposition" ref="a2a45fd744a4ccfac9ed86578acf4923a" args="(Vector3 &amp;position, Vector3 &amp;scale, Quaternion &amp;orientation) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Matrix4.html#a2a45fd744a4ccfac9ed86578acf4923a">Ogre::Matrix4::decomposition</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>position</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>scale</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>orientation</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Decompose a <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> to orientation / scale / position. </p>

</div>
</div>
<a class="anchor" id="a7e14122cbf6856b9701142cb6580aaa1"></a><!-- doxytag: member="Ogre::Matrix4::determinant" ref="a7e14122cbf6856b9701142cb6580aaa1" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Matrix4.html#a7e14122cbf6856b9701142cb6580aaa1">Ogre::Matrix4::determinant</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a7c32a3b5d7675181995e917f66c18b69"></a><!-- doxytag: member="Ogre::Matrix4::extract3x3Matrix" ref="a7c32a3b5d7675181995e917f66c18b69" args="(Matrix3 &amp;m3x3) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Matrix4.html#a7c32a3b5d7675181995e917f66c18b69">Ogre::Matrix4::extract3x3Matrix</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;&#160;</td>
          <td class="paramname"><em>m3x3</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Extracts the rotation / scaling part of the Matrix as a 3x3 matrix. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">m3x3</td><td>Destination <a class="el" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00463">463</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix3_8h_source.html#l00278">Ogre::Matrix3::m</a>.</p>

</div>
</div>
<a class="anchor" id="ae66aaed3ab33c1f2a9862bc21dde0608"></a><!-- doxytag: member="Ogre::Matrix4::extractQuaternion" ref="ae66aaed3ab33c1f2a9862bc21dde0608" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> <a class="el" href="classOgre_1_1Matrix4.html#ae66aaed3ab33c1f2a9862bc21dde0608">Ogre::Matrix4::extractQuaternion</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Extracts the rotation / scaling part as a quaternion from the Matrix. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00502">502</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="adfddc3e047c6052647ebfa5ddb3fbe13"></a><!-- doxytag: member="Ogre::Matrix4::getScale" ref="adfddc3e047c6052647ebfa5ddb3fbe13" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#adfddc3e047c6052647ebfa5ddb3fbe13">Ogre::Matrix4::getScale</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets a scale matrix. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00436">436</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::z</a>.</p>

</div>
</div>
<a class="anchor" id="a5bac8a5777be6cf9af08c98de120d562"></a><!-- doxytag: member="Ogre::Matrix4::getScale" ref="a5bac8a5777be6cf9af08c98de120d562" args="(Real s_x, Real s_y, Real s_z)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#adfddc3e047c6052647ebfa5ddb3fbe13">Ogre::Matrix4::getScale</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>s_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>s_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>s_z</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets a scale matrix - variation for not using a vector. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00449">449</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>.</p>

</div>
</div>
<a class="anchor" id="a928e9a44acf0f5a998392b272b117a4f"></a><!-- doxytag: member="Ogre::Matrix4::getTrans" ref="a928e9a44acf0f5a998392b272b117a4f" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1Matrix4.html#a928e9a44acf0f5a998392b272b117a4f">Ogre::Matrix4::getTrans</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Extracts the translation transformation part of the matrix. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00368">368</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="a88fb90dffc0216a0a59bf19fad4eeace"></a><!-- doxytag: member="Ogre::Matrix4::getTrans" ref="a88fb90dffc0216a0a59bf19fad4eeace" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#a928e9a44acf0f5a998392b272b117a4f">Ogre::Matrix4::getTrans</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets a translation matrix. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00394">394</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::z</a>.</p>

</div>
</div>
<a class="anchor" id="a3eedf9b0ea1245683a20f2e98ebd7e42"></a><!-- doxytag: member="Ogre::Matrix4::getTrans" ref="a3eedf9b0ea1245683a20f2e98ebd7e42" args="(Real t_x, Real t_y, Real t_z)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#a928e9a44acf0f5a998392b272b117a4f">Ogre::Matrix4::getTrans</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>t_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>t_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>t_z</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets a translation matrix - variation for not using a vector. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00408">408</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>.</p>

</div>
</div>
<a class="anchor" id="ad7b6df8db31a975c7d8e0b255bce236b"></a><!-- doxytag: member="Ogre::Matrix4::hasNegativeScale" ref="ad7b6df8db31a975c7d8e0b255bce236b" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1Matrix4.html#ad7b6df8db31a975c7d8e0b255bce236b">Ogre::Matrix4::hasNegativeScale</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Determines if this matrix involves a negative scaling. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00495">495</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="a15aa8cfb2a09630c58c053649242d369"></a><!-- doxytag: member="Ogre::Matrix4::hasScale" ref="a15aa8cfb2a09630c58c053649242d369" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1Matrix4.html#a15aa8cfb2a09630c58c053649242d369">Ogre::Matrix4::hasScale</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Determines if this matrix involves a scaling. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00478">478</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1Math.html#a890336e0e4b6914024bfefd79c08f432">Ogre::Math::RealEqual()</a>.</p>

</div>
</div>
<a class="anchor" id="a8879acb17e3029cf8bc2796b29ed8470"></a><!-- doxytag: member="Ogre::Matrix4::inverse" ref="a8879acb17e3029cf8bc2796b29ed8470" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#a8879acb17e3029cf8bc2796b29ed8470">Ogre::Matrix4::inverse</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a48cec18b03b16a9161d1c95b493a38a4"></a><!-- doxytag: member="Ogre::Matrix4::inverseAffine" ref="a48cec18b03b16a9161d1c95b493a38a4" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#a48cec18b03b16a9161d1c95b493a38a4">Ogre::Matrix4::inverseAffine</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the inverse of the affine matrix. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>The matrix must be an affine matrix. </dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Matrix4.html#a582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">Matrix4::isAffine</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="a582b20b912ed7d7f8f179505dfbe7a4e"></a><!-- doxytag: member="Ogre::Matrix4::isAffine" ref="a582b20b912ed7d7f8f179505dfbe7a4e" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1Matrix4.html#a582b20b912ed7d7f8f179505dfbe7a4e">Ogre::Matrix4::isAffine</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Check whether or not the matrix is affine matrix. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>An affine matrix is a 4x4 matrix with row 3 equal to (0, 0, 0, 1), e.g. no projective coefficients. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00572">572</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>Referenced by <a class="el" href="OgreMatrix4_8h_source.html#l00587">concatenateAffine()</a>, and <a class="el" href="OgreAxisAlignedBox_8h_source.html#l00508">Ogre::AxisAlignedBox::transformAffine()</a>.</p>

</div>
</div>
<a class="anchor" id="a4e5949d1d1004070660f31036ee69523"></a><!-- doxytag: member="Ogre::Matrix4::makeInverseTransform" ref="a4e5949d1d1004070660f31036ee69523" args="(const Vector3 &amp;position, const Vector3 &amp;scale, const Quaternion &amp;orientation)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Matrix4.html#a4e5949d1d1004070660f31036ee69523">Ogre::Matrix4::makeInverseTransform</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>position</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>scale</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>orientation</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Building an inverse <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> from orientation / scale / position. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>As makeTransform except it build the inverse given the same data as makeTransform, so performing -translation, -rotate, 1/scale in that order. </dd></dl>

</div>
</div>
<a class="anchor" id="afb53c4fa6548001260d77dc283e3652f"></a><!-- doxytag: member="Ogre::Matrix4::makeTrans" ref="afb53c4fa6548001260d77dc283e3652f" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Matrix4.html#afb53c4fa6548001260d77dc283e3652f">Ogre::Matrix4::makeTrans</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Builds a translation matrix. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00376">376</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::z</a>.</p>

</div>
</div>
<a class="anchor" id="a87f478c5d19a10a371b736108e0b5e5f"></a><!-- doxytag: member="Ogre::Matrix4::makeTrans" ref="a87f478c5d19a10a371b736108e0b5e5f" args="(Real tx, Real ty, Real tz)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Matrix4.html#afb53c4fa6548001260d77dc283e3652f">Ogre::Matrix4::makeTrans</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>tx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>ty</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>tz</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00384">384</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="a283bf568c924a673a1467c428d4b969d"></a><!-- doxytag: member="Ogre::Matrix4::makeTransform" ref="a283bf568c924a673a1467c428d4b969d" args="(const Vector3 &amp;position, const Vector3 &amp;scale, const Quaternion &amp;orientation)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Matrix4.html#a283bf568c924a673a1467c428d4b969d">Ogre::Matrix4::makeTransform</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>position</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>scale</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>orientation</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Building a <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> from orientation / scale / position. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Transform is performed in the order scale, rotate, translation, i.e. translation is independent of orientation axes, scale does not affect size of translation, rotation and scaling are always centered on the origin. </dd></dl>

</div>
</div>
<a class="anchor" id="a67d3ae14b6b68e6824f1a91d99da16f8"></a><!-- doxytag: member="Ogre::Matrix4::operator!=" ref="a67d3ae14b6b68e6824f1a91d99da16f8" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Matrix4::operator!= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>m2</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Tests 2 matrices for inequality. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00324">324</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>.</p>

</div>
</div>
<a class="anchor" id="a7afd9c17be1a09da49b11b2c1a9e4ccb"></a><!-- doxytag: member="Ogre::Matrix4::operator*" ref="a7afd9c17be1a09da49b11b2c1a9e4ccb" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::operator* </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>m2</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Matrix concatenation using '*'. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00202">202</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9a46d183f9470d7608e50a43ef327b46"></a><!-- doxytag: member="Ogre::Matrix4::operator*" ref="a9a46d183f9470d7608e50a43ef327b46" args="(const Vector3 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::Matrix4::operator* </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Vector transformation using '*'. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Transforms the given 3-D vector by the matrix, projecting the result back into <em>w</em> = 1. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This means that the initial <em>w</em> is considered to be 1.0, and then all the tree elements of the resulting 3-D vector are divided by the resulting <em>w</em>. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00216">216</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::z</a>.</p>

</div>
</div>
<a class="anchor" id="ab120b3153610d0c92fe0876249c7d3ae"></a><!-- doxytag: member="Ogre::Matrix4::operator*" ref="ab120b3153610d0c92fe0876249c7d3ae" args="(const Vector4 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a> Ogre::Matrix4::operator* </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00228">228</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector4_8h_source.html#l00048">Ogre::Vector4::w</a>, <a class="el" href="OgreVector4_8h_source.html#l00048">Ogre::Vector4::x</a>, <a class="el" href="OgreVector4_8h_source.html#l00048">Ogre::Vector4::y</a>, and <a class="el" href="OgreVector4_8h_source.html#l00048">Ogre::Vector4::z</a>.</p>

</div>
</div>
<a class="anchor" id="adf4c418aa94944129f99dacd90ca29dd"></a><!-- doxytag: member="Ogre::Matrix4::operator*" ref="adf4c418aa94944129f99dacd90ca29dd" args="(const Plane &amp;p) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html">Plane</a> Ogre::Matrix4::operator* </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00237">237</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgrePlane_8h_source.html#l00145">Ogre::Plane::d</a>, <a class="el" href="OgrePlane_8h_source.html#l00144">Ogre::Plane::normal</a>, <a class="el" href="OgreVector3_8h_source.html#l00442">Ogre::Vector3::normalise()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00344">transpose()</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::z</a>.</p>

</div>
</div>
<a class="anchor" id="a33a5f250207da657e2dab3b3aa5f4d72"></a><!-- doxytag: member="Ogre::Matrix4::operator*" ref="a33a5f250207da657e2dab3b3aa5f4d72" args="(Real scalar) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::operator* </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>scalar</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00516">516</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac0c54ddc64f9b832ab2656f514060fbb"></a><!-- doxytag: member="Ogre::Matrix4::operator+" ref="ac0c54ddc64f9b832ab2656f514060fbb" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::operator+ </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>m2</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Matrix addition. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00254">254</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>.</p>

</div>
</div>
<a class="anchor" id="a6c698c19379d5b4d2ff6e5dd186ad76c"></a><!-- doxytag: member="Ogre::Matrix4::operator&#45;" ref="a6c698c19379d5b4d2ff6e5dd186ad76c" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::operator- </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>m2</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Matrix subtraction. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00283">283</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>.</p>

</div>
</div>
<a class="anchor" id="a5c5f37c501d49692728909d11dd8c1de"></a><!-- doxytag: member="Ogre::Matrix4::operator=" ref="a5c5f37c501d49692728909d11dd8c1de" args="(const Matrix3 &amp;mat3)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Matrix4::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;&#160;</td>
          <td class="paramname"><em>mat3</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Assignment from 3x3 matrix. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00337">337</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix3_8h_source.html#l00278">Ogre::Matrix3::m</a>.</p>

</div>
</div>
<a class="anchor" id="a5eb73fdc4084eed850221ed14f558ff2"></a><!-- doxytag: member="Ogre::Matrix4::operator==" ref="a5eb73fdc4084eed850221ed14f558ff2" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Matrix4::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>m2</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Tests 2 matrices for equality. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00311">311</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>.</p>

</div>
</div>
<a class="anchor" id="aa996041c004dbfd5629120299ee0cb6f"></a><!-- doxytag: member="Ogre::Matrix4::operator[]" ref="aa996041c004dbfd5629120299ee0cb6f" args="(size_t iRow)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>* Ogre::Matrix4::operator[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>iRow</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00162">162</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9e799f2922b54ced115226b14b1d3a0b"></a><!-- doxytag: member="Ogre::Matrix4::operator[]" ref="a9e799f2922b54ced115226b14b1d3a0b" args="(size_t iRow) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>* Ogre::Matrix4::operator[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>iRow</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00168">168</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="a754a168ea4d55d40c9a24ef33eb41c95"></a><!-- doxytag: member="Ogre::Matrix4::setScale" ref="a754a168ea4d55d40c9a24ef33eb41c95" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Matrix4.html#a754a168ea4d55d40c9a24ef33eb41c95">Ogre::Matrix4::setScale</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the scale part of the matrix. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00427">427</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::z</a>.</p>

</div>
</div>
<a class="anchor" id="aaf08a89733aa192a0d9e414e8b18ccf1"></a><!-- doxytag: member="Ogre::Matrix4::setTrans" ref="aaf08a89733aa192a0d9e414e8b18ccf1" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Matrix4.html#aaf08a89733aa192a0d9e414e8b18ccf1">Ogre::Matrix4::setTrans</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the translation transformation part of the matrix. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00359">359</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::z</a>.</p>

</div>
</div>
<a class="anchor" id="a83b9aa92783c4679fc09307e74e92736"></a><!-- doxytag: member="Ogre::Matrix4::swap" ref="a83b9aa92783c4679fc09307e74e92736" args="(Matrix4 &amp;other)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Matrix4.html#a83b9aa92783c4679fc09307e74e92736">Ogre::Matrix4::swap</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Exchange the contents of this matrix with another. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00142">142</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h_source.html#l00083">m</a>, and <a class="el" href="OgreSmallVector_8h_source.html#l00802">std::swap()</a>.</p>

</div>
</div>
<a class="anchor" id="afcd6dae51beb8283338ad52ac63c86fb"></a><!-- doxytag: member="Ogre::Matrix4::transformAffine" ref="afcd6dae51beb8283338ad52ac63c86fb" args="(const Vector3 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1Matrix4.html#afcd6dae51beb8283338ad52ac63c86fb">Ogre::Matrix4::transformAffine</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>3-D Vector transformation specially for an affine matrix. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Transforms the given 3-D vector by the matrix, projecting the result back into <em>w</em> = 1. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>The matrix must be an affine matrix. </dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Matrix4.html#a582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">Matrix4::isAffine</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00617">617</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h_source.html#l00054">Ogre::Vector3::z</a>.</p>

<p>Referenced by <a class="el" href="OgreAxisAlignedBox_8h_source.html#l00508">Ogre::AxisAlignedBox::transformAffine()</a>.</p>

</div>
</div>
<a class="anchor" id="a30bacec4331db3d61f8a43a0d8596595"></a><!-- doxytag: member="Ogre::Matrix4::transformAffine" ref="a30bacec4331db3d61f8a43a0d8596595" args="(const Vector4 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a> <a class="el" href="classOgre_1_1Matrix4.html#afcd6dae51beb8283338ad52ac63c86fb">Ogre::Matrix4::transformAffine</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>4-D Vector transformation specially for an affine matrix. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>The matrix must be an affine matrix. </dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Matrix4.html#a582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">Matrix4::isAffine</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00631">631</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector4_8h_source.html#l00048">Ogre::Vector4::w</a>, <a class="el" href="OgreVector4_8h_source.html#l00048">Ogre::Vector4::x</a>, <a class="el" href="OgreVector4_8h_source.html#l00048">Ogre::Vector4::y</a>, and <a class="el" href="OgreVector4_8h_source.html#l00048">Ogre::Vector4::z</a>.</p>

</div>
</div>
<a class="anchor" id="ae141496dd80a027493cfc0bea3952a4d"></a><!-- doxytag: member="Ogre::Matrix4::transpose" ref="ae141496dd80a027493cfc0bea3952a4d" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#ae141496dd80a027493cfc0bea3952a4d">Ogre::Matrix4::transpose</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00344">344</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>Referenced by <a class="el" href="OgreMatrix4_8h_source.html#l00237">operator*()</a>.</p>

</div>
</div>
<hr/><h2>Friends And Related Function Documentation</h2>
<a class="anchor" id="aa690d21c6464462d97145c8071ca5c29"></a><!-- doxytag: member="Ogre::Matrix4::operator&lt;&lt;" ref="aa690d21c6464462d97145c8071ca5c29" args="(std::ostream &amp;o, const Matrix4 &amp;mat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&#160;</td>
          <td class="paramname"><em>mat</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Function for writing to a stream. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00528">528</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a64e62f0586dd8550fd6b0fa0b6d200b5"></a><!-- doxytag: member="Ogre::Matrix4::@6" ref="a64e62f0586dd8550fd6b0fa0b6d200b5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">union { ... } <code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The matrix entries, indexed by [row][col]. </p>

</div>
</div>
<a class="anchor" id="a0d9aaf75aa94b65f4ec5fe1afb0cf4d1"></a><!-- doxytag: member="Ogre::Matrix4::_m" ref="a0d9aaf75aa94b65f4ec5fe1afb0cf4d1" args="[16]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Matrix4.html#a0d9aaf75aa94b65f4ec5fe1afb0cf4d1">Ogre::Matrix4::_m</a>[16]</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00084">84</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="a08a798c0d8c8290dbc0287ca6561f549"></a><!-- doxytag: member="Ogre::Matrix4::CLIPSPACE2DTOIMAGESPACE" ref="a08a798c0d8c8290dbc0287ca6561f549" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#a08a798c0d8c8290dbc0287ca6561f549">Ogre::Matrix4::CLIPSPACE2DTOIMAGESPACE</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Useful little matrix which takes 2D clipspace {-1, 1} to {0,1} and inverts the Y. </p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00514">514</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="af2f61127dd1911c9ac2b4cbc0b4f3668"></a><!-- doxytag: member="Ogre::Matrix4::IDENTITY" ref="af2f61127dd1911c9ac2b4cbc0b4f3668" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#af2f61127dd1911c9ac2b4cbc0b4f3668">Ogre::Matrix4::IDENTITY</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00511">511</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>Referenced by <a class="el" href="OgreInstancedEntity_8h_source.html#l00251">Ogre::InstancedEntity::_getParentNodeFullTransform()</a>.</p>

</div>
</div>
<a class="anchor" id="a949708616d61b1c520d04bd9b0577324"></a><!-- doxytag: member="Ogre::Matrix4::m" ref="a949708616d61b1c520d04bd9b0577324" args="[4][4]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Matrix4.html#a949708616d61b1c520d04bd9b0577324">Ogre::Matrix4::m</a>[4][4]</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00083">83</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

<p>Referenced by <a class="el" href="OgreMatrix4_8h_source.html#l00174">concatenate()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00587">concatenateAffine()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00436">getScale()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00394">getTrans()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00324">operator!=()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00254">operator+()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00283">operator-()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00311">operator==()</a>, and <a class="el" href="OgreMatrix4_8h_source.html#l00142">swap()</a>.</p>

</div>
</div>
<a class="anchor" id="a838ac3cb744a01a39dfe35c61e942d7a"></a><!-- doxytag: member="Ogre::Matrix4::ZERO" ref="a838ac3cb744a01a39dfe35c61e942d7a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#a838ac3cb744a01a39dfe35c61e942d7a">Ogre::Matrix4::ZERO</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00509">509</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae2c11de10a963ad13ce3d3e802a05d60"></a><!-- doxytag: member="Ogre::Matrix4::ZEROAFFINE" ref="ae2c11de10a963ad13ce3d3e802a05d60" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#ae2c11de10a963ad13ce3d3e802a05d60">Ogre::Matrix4::ZEROAFFINE</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMatrix4_8h_source.html#l00510">510</a> of file <a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreMatrix4_8h_source.html">OgreMatrix4.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:59
</p>
</body>
</html>
